<?php

class LookAlike {

    static protected $config = null;

    /**
     * Init la config de LookAlike
     *
     * @param array $config :
     *  - position : tracking_footer | tracking_header
     *  - pa : xxxxxx
     */
    static public function init($config = array()) {
        self::$config = $config;
    }

    /**
     * Check if LookAlike is initialized
     * If not, trigger a warning error
     */
    static protected function triggerErrorIfNotInit() {
        if (is_null(self::$config)) {
            trigger_error("LookAlike n'est pas initialis�", E_USER_WARNING);
        }
    }

    /**
     * @param array $param
     */
    static public function index($param = array()) {

        self::triggerErrorIfNotInit();


        $out = '<script type="text/javascript">
                    (function(){
                        var service = "LAL.d";
                        var config = {
                            pa : "' .self::$config['pa'] . '",
                            u : document.location.href,
                            r : document.referrer,
                        };
                        var configParams = [];

                        for(var v in config){
                            configParams .push(v+"="+encodeURIComponent(config[v]));
                        }

                        var sddanJS=document.createElement("script");
                        sddanJS.async = true;
                        sddanJS.src="//js.sddan.com/"+service+"?"+ configParams.join("&");
                        document.getElementsByTagName("head")[0].appendChild(sddanJS);
                    })();
                </script>';

        if (isset($param['smarty'])) {
            $param['smarty']->assign(self::$config['position'], $out);
        }
    }

    /**
     * @param array $param
     */
    static public function listing($param = array()) {

        self::triggerErrorIfNotInit();

        $sep = '.';

        $list['produits_ids'] = "";
        $list['produits_noms'] = "";
        $list['produits_prix'] = "";

        foreach ($param['extra'] as $prod) {
            $list['produits_ids'] .= $prod['produit_id'] . $sep;
            $list['produits_noms'] .= $prod['produit_nom_nom'] . $sep;
            $list['produits_prix'] .= $prod['produit_prix_ttc'] . $sep;
        }

        $out = '<script type="text/javascript">
                    (function(){
                        var service = "product.d";
                        var config = {
                            pa : "' .self::$config['pa'] . '",
                            u : document.location.href,
                            r : document.referrer,
                            product_id : "' . $list['produits_ids'] . '",
                            product_name : "' . $list['produits_noms'] . '",
                            product_price : "' . $list['produits_prix'] . '"
                        };
                        var configParams = [];

                        for(var v in config){
                            configParams .push(v+"="+encodeURIComponent(config[v]));
                        }

                        var sddanJS=document.createElement("script"); sddanJS.async = true;
                        sddanJS.src="//js.sddan.com/"+service+"?"+ configParams.join("&");
                        document.getElementsByTagName("head")[0].appendChild(sddanJS);
                    })();
                </script>';

        if (isset($param['smarty'])) {
            $param['smarty']->reassign(self::$config['position'], $out);
        }
    }

    /**
     * @param array $param
     */
    static public function produit($param = array()) {

        self::triggerErrorIfNotInit();

        $out = '<script type="text/javascript">
                    (function(){
                        var service = "product.d";
                        var config = {
                            pa : "' .self::$config['pa'] . '",
                            u : document.location.href,
                            r : document.referrer,
                            product_id : "' . $param['produit_id'] . '",
                            product_name : "' . $param['produit_nom_nom'] . '",
                            product_price : "' . $param['produit_prix_ttc'] . '"
                        };
                        var configParams = [];

                        for(var v in config){
                            configParams .push(v+"="+encodeURIComponent(config[v]));
                        }

                        var sddanJS=document.createElement("script"); sddanJS.async = true;
                        sddanJS.src="//js.sddan.com/"+service+"?"+ configParams.join("&");
                        document.getElementsByTagName("head")[0].appendChild(sddanJS);
                    })();
                </script>';

        if (isset($param['smarty'])) {
            $param['smarty']->reassign(self::$config['position'], $out);
        }
    }

    /**
     * @param array $param
     */
    static public function panier($param = array()) {
        self::triggerErrorIfNotInit();

        $sep = '.';

        $listProduitIds = '';

        foreach($param['extra'] as $k => $prod) {
            if ($k != 'commande_total_ttc') {
                $listProduitIds .= $prod['produit_id'] . $sep;
            }
        }

        $out = '<script type="text/javascript">
                    (function(){
                        var service = "cart.d";
                        var config = {
                            pa : "' .self::$config['pa'] . '",
                            u : document.location.href,
                            r : document.referrer,
                            command_amount : "' . $param['extra']['commande_total_ttc'] . '",
                            product_id : "' . $listProduitIds . '"
                        };
                        var configParams = [];

                        for(var v in config){
                            configParams .push(v+"="+encodeURIComponent(config[v]));
                        }

                        var sddanJS=document.createElement("script");
                        sddanJS.async = true;
                        sddanJS.src="//js.sddan.com/"+service+"?"+ configParams.join("&"); document.getElementsByTagName("head")[0].appendChild(sddanJS);
                    })();
                </script>';

        if (isset($param['smarty'])) {
            $param['smarty']->reassign(self::$config['position'], $out);
        }
    }

    /**
     * @param array $param
     */
    static public function recapitulatif($param = array()) {

        self::triggerErrorIfNotInit();

        $out = '<script type="text/javascript">
                    (function(){
                        var service = "order.d";
                        var config = {
                            pa : "' .self::$config['pa'] . '",
                            ht_paid : "0",
                            u : document.location.href,
                            r : document.referrer,
                            command_amount : "' . str_replace(".", ",", $param['extra']['commande_total_ttc']) . '"
                        };
                        var configParams = [];

                        for(var v in config){
                            configParams .push(v+"="+encodeURIComponent(config[v]));
                        }

                        var sddanJS=document.createElement("script");
                        sddanJS.async = true;
                        sddanJS.src="//js.sddan.com/"+service+"?"+ configParams.join("&");
                        document.getElementsByTagName("head")[0].appendChild(sddanJS);
                    })();
                </script>';

        if (isset($param['smarty'])) {
            $param['smarty']->reassign(self::$config['position'], $out);
        }
    }

    /**
     * @param array $param
     */
    static public function paiement($param = array()) {

        self::triggerErrorIfNotInit();

        $out = '<script type="text/javascript">
                    (function(){
                        var service = "order.d";
                        var config = {
                            pa : "' .self::$config['pa'] . '",
                            ht_paid : "1",
                            u : document.location.href,
                            r : document.referrer,
                            command_amount : "' . str_replace(".", ",", $param['extra']['commande_total_ttc']) . '"
                        };
                        var configParams = [];

                        for(var v in config){
                            configParams .push(v+"="+encodeURIComponent(config[v]));
                        }

                        var sddanJS=document.createElement("script");
                        sddanJS.async = true;
                        sddanJS.src="//js.sddan.com/"+service+"?"+ configParams.join("&");
                        document.getElementsByTagName("head")[0].appendChild(sddanJS);
                    })();
                </script>';

        if (isset($param['smarty'])) {
            $param['smarty']->reassign(self::$config['position'], $out);
        }
    }
}